NB. parse.fp - I must be mad.

NB.--Parser entry point----------------------------------------------------------

NB. parse:<TOKEN, ...> -> TREE
NB.   TOKEN = <CLASS, LINE[, ARG]>

parse = p_program where

NB.--Parse rules-----------------------------------------------------------------

NB. p_...:<TOKEN, ...> -> <<TOKEN', ...>, TREE> | F

NB. program -> toplevel [separator [program]]
NB. separator -> "." | ","

p_program = null -> parse_error[~"unexpected end of input", ~1];
            p_program' (p_toplevel | parse_error[~"invalid toplevel form", 2 1]).
p_program' = 
  {null | {separator}, top=} -> [top];
  {{separator, ...}, top=} -> p_program''[-1 1, top];
  parse_error[~"unrecognized input", 2 1 1].
p_program'' = apndl[2, p_program 1].
separator = {`COMMA | `PERIOD, #}.

NB. toplevel -> definition ["where" program "end"]
NB.          |  application

p_toplevel = (1 -> p_toplevel' 1; p_toplevel''' 2) [p_definition, id].
p_toplevel' = 
  {{{`WHERE, #}, more=...}, def=} -> p_toplevel'' *p_program[more 1, def];
  id.
p_toplevel'' = 
  {{{`END, #}, more=...}, prg=, def=} -> [more 1, cat[[~"where", def], prg]];
  parse_error[~"missing `end'", 2 1].
p_toplevel''' = p_sequence | p_application.

NB. application -> expr ":" object

p_application = p_application' p_expr.
p_application' =
  {{{`APP, #}, more=...}, ex=} -> p_application'' *p_object[more 1, ex];
  ~F.
p_application''{{tokens=, obj=}, ex=} = [tokens 1, [~"app", ex, obj 1]].

NB. definition -> head pconstruction "=" expr
NB.            |  head "=" expr
NB. head -> "(" id ")"
NB.      |  id

p_definition = 
  {{`ID, #, ident=}, more=...} -> p_definition'[more, ident 1, ~F];
  {{`OPAREN, #}, {`ID, #, ident=}, {`CPAREN, #}, more=...} -> p_definition'[more, ident 2, ~T];
  ~F.
p_definition' =
  {{t1=, more=...}, ident=, mem=} ->
    ({`EQUAL, #} t1 1 -> p_definition'' *p_expr[more 1, ident, mem];
     {`OBRACKET, #} t1 1 -> p_definition''' *p_pconstruction[1, ident, mem];
     ~F);
  ~F.
p_definition''{{tokens=, ex=}, ident=, mem=} = 
  [tokens 1, [~"def", mem -> [~"once", ident]; ident, ex 1]].
p_definition'''{{tokens=, pcons=}, ident=, mem=} = 
  p_definition'''' *p_expr[tokens 1, pcons 1, ident, mem].
p_definition''''{{tokens=, ex=}, pcons=, ident=, mem=} =
  [tokens 1, [~"def", mem -> [~"once", ident]; ident, 
    [~"cond", pcons, ex 1, ~<"bottom", "failed match">]]].

NB. expr -> expr1 ["->" expr1 ";" expr]

p_expr = p_expr' p_expr1.
p_expr' = {{{`ARROW, #}, ...}, ex=} -> p_expr'' *p_expr1[-1 1, ex]; id.
p_expr''{val=, ex=} = 
  {{}, #} val -> parse_error[~"unexpected end of file while parsing `-> ...'", ~1];
  {{{`SEMICOLON, #}, ...}, ex2=} val -> p_expr''' *p_expr[-1 1 val, ex2 val, ex];
  parse_error[~"missing `;'", 2 1 val].
p_expr'''{{tokens=, ex3=}, ex2=, ex=} = [tokens 1, [~"cond", ex, ex2, ex3]].

NB. expr1 -> "while" expr2 expr1
NB.       |  "catch" expr2 expr
NB.       |  expr2 "|" expr1
NB.	  |  expr2 "&" expr1
NB.	  |  expr2 [expr1]

p_expr1 = {{`WHILE, #}, ...} -> p_expr1' p_expr2 -1;
          {{`CATCH, #}, ...} -> p_expr1'' p_expr2 -1;
          p_expr1''' p_expr2.
p_expr1'{tokens=, ex=} = [1 1, [~"while", 2 1, 2]] *p_expr1[tokens, ex].
p_expr1''{tokens=, ex=} = [1 1, [~"catch", 2 1, 2]] *p_expr[tokens, ex].
p_expr1''' =
  not -> ~F;
  {{{`OR, #}, ...}, ex=} -> 
    [1 1, [~"comp", [~"cond", ~<"select", 1>, ~<"select", 1>
                              [~"comp", 2 1, ~<"select", 2>] ]
                    [~"cons", ex, ~"id"] ] ]
      *p_expr1[-1 1, ex];
  {{{`AND, #}, ...}, ex=} -> 
    [1 1, [~"cond", ex, 2 1, ~<"const", <"atom", F>>]] *p_expr1[-1 1, ex];
  p_expr1'''' *p_expr1[1, 2, 1].
p_expr1'''' = {not, ex=, tokens=} -> [tokens, ex];
	      [1 1, [~"comp", 2, 2 1]].

NB. expr2 -> "bu" value object
NB.       |  "*" expr2
NB.       |  "/" expr2
NB.       |  "\" expr2
NB.       |  "@" expr2
NB.       |  "(" expr ")"
NB.       |  construction
NB.       |  pconstruction
NB.       |  value

p_expr2 =
  {{`BU, #}, ...} -> p_expr2' *p_value[-1, 2 1];
  {{`LIFT, #}, ...} -> 
    [-1 1, [~"comp", ~"apndl", [~"cons", [~"comp", 2, ~<"select", 1>], 
                                         ~<"select", -1>]]] p_expr2 -1;
  {{`INSERT, #}, ...} -> [1, [~"insert", 2]] p_expr2 -1;
  {{`INSERTR, #}, ...} -> [1, [~"insert-right", 2]] p_expr2 -1;
  {{`ALPHA, #}, ...} -> [1, [~"insert-alpha", 2]] p_expr2 -1;
  {{`OPAREN, #}, ...} -> p_expr2'' *p_expr[-1, 2 1];
  {{`OBRACKET, #}, ...} -> p_construction;
  {{`OCURLY, #}, ...} -> p_pconstruction;
  p_value.
p_expr2'{val=, line=} =
  not val -> parse_error[~"missing arguments to `bu'", line];
  [1 1, [~"bu", 2, 2 1]] *p_object val.      NB. should actually check for missing 2nd arg
p_expr2''{val=, line=} =
  not val -> parse_error[~"unpexpected end of input", line];
  {{{`CPAREN, #}, ...}, x=} val -> [-1 1, x] val;
  parse_error[~"missing `)'", line].

NB. sequence -> "<" object "," ... ">"

p_sequence =
  {{`OSEQUENCE, #}, {`CSEQUENCE, #}, ...} -> [-2, ~<"seq">];
  {{`OSEQUENCE, #}, ...} -> p_sequence' p_obj_list -1;
  ~F.
p_sequence' = 
  {{{`CSEQUENCE, #}, ...}, olist=} -> [-1 1, apndl[~"seq", olist]];
  parse_error[~"missing `>'", 2 1 1].
p_obj_list = (p_obj_list' p_object) | (parse_error[~"missing object in `<...>'", 2 1]).
p_obj_list' =
  not -> id;
  {{{`COMMA, #}, ...}, ex=} -> [1 1, apndl[2, 2 1]] *p_obj_list[-1 1, ex];
  [1, [2]].

NB. pconstruction -> "{" pattern "," ... "}"

p_pconstruction =
  {{`OCURLY, #}, {`CCURLY, #}, ...} -> [-2, ~<"pcons">];
  {{`OCURLY, #}, ...} -> p_pconstruction' p_pat_list -1;
  ~F.
p_pconstruction' = 
  {{{`CCURLY, #}, ...}, plist=} -> [-1 1, apndl[~"pcons", plist]];
  parse_error[~"missing `}'", 2 1 1].
p_pat_list = (p_pat_list' p_pattern) | (parse_error[~"missing object in `{...}'", 2 1]).
p_pat_list' =
  not -> id;
  {{{`COMMA, #}, ...}, ex=} -> [1 1, apndl[2, 2 1]] *p_pat_list[-1 1, ex];
  [1, [2]].

NB. pattern -> identifier ["=" [pattern]]
NB.         |  "#"
NB.         |  "..."
NB.         |  expr

p_pattern =
  {{`ID, #, name=}, {`EQUAL, #}, ...} -> p_pattern' *p_pattern[-2, name 1, 1];
  {{`SHARP, #}, ...} -> [-1, ~<"const", <"atom", T>>];
  {{`DOTS, #}, ...} -> [-1, ~"..."];
  p_expr.
p_pattern' =
  {not, name=, tokens=} -> [tokens, [~"let", name, ~<"const", <"atom", T>>]];
  {{tokens=, pat=}, name=, #} -> [tokens 1, [~"let", name, pat 1]];
  ~F.

NB. construction -> "[" expr "," ... "]"

p_construction =
  {{`OBRACKET, #}, {`CBRACKET, #}, ...} -> [-2, ~<"cons">];
  {{`OBRACKET, #}, ...} -> p_construction' p_expr_list -1;
  ~F.
p_construction' = 
  {{{`CBRACKET, #}, ...}, elist=} -> [-1 1, apndl[~"cons", elist]];
  parse_error[~"missing `]'", 2 1 1].

p_expr_list = (p_expr_list' p_expr) | (parse_error[~"missing expression in `[...]'", 2 1]).
p_expr_list' =
  not -> id;
  {{{`COMMA, #}, ...}, ex=} -> [1 1, apndl[2, 2 1]] *p_expr_list[-1 1, ex];
  [1, [2]].

NB. value -> "_"
NB.       |  "~" object
NB.       |  "`" object
NB.       |  number
NB.       |  identifier
NB.       |  "debug" atom
NB.       |  "verbatim" atom

p_value =
  {{`BOTTOM, #}, ...} -> [-1, ~<"bottom", "undefined">];
  {{`NUM, #, n=}, ...} -> [-1, [~"select", n 1]];
  {{`CONST, #}, ...} -> [1, [~"const", 2]] p_object -1;
  {{`EQ0, #}, ...} -> [1, [~"bu", ~"eq", 2]] p_object -1;
  {{`DEBUG, #}, {`ATOM, #, msg=}, ...} -> [-2, [~"debug", msg 2]];
  {{`ID, #, name=}, ...} -> [-1, name 1];
  {{`VERBATIM, #}, {`ATOM, #, atm=}, ...} -> [-2, [~"verbatim", atm 2]];
  ~F.

NB. object -> number
NB.        |  character
NB.        |  atom
NB.        |  "#"
NB.        |  sequence
NB.        |  "verbatim" atom

p_object = 
  {{`NUM | `CHAR, #, n=}, ...} -> [-1, n 1];
  {{`ATOM, #, a=}, ...} -> [-1, [~"atom", a 1]];
  {{`SHARP, #}, ...} -> [-1, ~<"atom", "#">];
  {{`OSEQUENCE, #}, ...} -> p_sequence;
  {{`VERBATIM, #}, {`ATOM, #, atm=}, ...} -> [-2, [~"verbatim", atm 2]];
  ~F.

NB.--Error reporting-------------------------------------------------------------

NB. parse_error:<MSG, LINE, ARG1, ...>

parse_error{msg=, line=, args=...} =
  throw[merge[~"parser error in line ", line, ~": ", msg], args].

end.
